#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <ogcsys.h>
#include <gccore.h>
#include <ogc/ipc.h>
#include <network.h>

static void *xfb = NULL;
static GXRModeObj *rmode = NULL;
char message[256];
unsigned short port = 9001;
u32 ip;
u8 *splitip = (u8 *)&ip;
void (*reload)() = (void(*)())0x09000000;

typedef struct
{
	bool A;
	bool B;
	bool X;
	bool Y;
	bool Z;
	bool L;
	bool R;
	bool UP;
	bool DOWN;
	bool LEFT;
	bool RIGHT;
	bool START;
	bool AUP;
	bool ADOWN;
	bool ALEFT;
	bool ARIGHT;
	bool CUP;
	bool CDOWN;
	bool CLEFT;
	bool CRIGHT;
} waitvars;
typedef struct
{
	u32 A,B,X,Y,Z,L,R,UP,DOWN,LEFT,RIGHT,START,AUP,ADOWN,ALEFT,ARIGHT,CUP,CDOWN,CLEFT,CRIGHT;
} buttonvars;

buttonvars Button;
waitvars wait;

// FUNTIONS

bool button_release(u8 controller, u8 button)
{
	if(button == Button.A)
	{
		if(PAD_ButtonsUp(controller)&PAD_BUTTON_A)
		{
			return 1;
		}
		else return 0;
	}
	else if(button == Button.B)
	{
		if(PAD_ButtonsUp(controller)&PAD_BUTTON_B)
		{
			return 1;
		}
		else return 0;
	}
	else if(button == Button.X)
	{
		if(PAD_ButtonsUp(controller)&PAD_BUTTON_X)
		{
			return 1;
		}
		else return 0;
	}
	else if(button == Button.Y)
	{
		if(PAD_ButtonsUp(controller)&PAD_BUTTON_Y)
		{
			return 1;
		}
		else return 0;
	}
	else if(button == Button.Z)
	{
		if(PAD_ButtonsUp(controller)&PAD_TRIGGER_Z)
		{
			return 1;
		}
		else return 0;
	}
	else if(button == Button.L)
	{
		if(PAD_ButtonsUp(controller)&PAD_TRIGGER_L)
		{
			return 1;
		}
		else return 0;
	}
	else if(button == Button.R)
	{
		if(PAD_ButtonsUp(controller)&PAD_TRIGGER_R)
		{
			return 1;
		}
		else return 0;
	}
	else if(button == Button.START)
	{
		if(PAD_ButtonsUp(controller)&PAD_BUTTON_START)
		{
			return 1;
		}
		else return 0;
	}
	else if(button == Button.UP)
	{
		if(PAD_ButtonsUp(controller)&PAD_BUTTON_UP)
		{
			return 1;
		}
		else return 0;
	}
	else if(button == Button.DOWN)
	{
		if(PAD_ButtonsUp(controller)&PAD_BUTTON_LEFT)
		{
			return 1;
		}
		else return 0;
	}
	else if(button == Button.LEFT)
	{
		if(PAD_ButtonsUp(controller)&PAD_BUTTON_LEFT)
		{
			return 1;
		}
		else return 0;
	}
	else if(button == Button.RIGHT)
	{
		if(PAD_ButtonsUp(controller)&PAD_BUTTON_RIGHT)
		{
			return 1;
		}
		else return 0;
	}
	else return 0;
}
bool button_newpress(u8 controller, u8 button)
{
	if(button == Button.A)
	{
		if(PAD_ButtonsDown(controller)&PAD_BUTTON_A)
		{
			if(wait.A==0)
			{
				wait.A = 1;
				return 1;
			}
			if(wait.A==1)
			{
				return 0;
			}
		}
		else if(PAD_ButtonsUp(controller)&PAD_BUTTON_A)
		{
			wait.A = 0;
			return 0;
		}
		else return 0;
	}
	else if(button == Button.B)
	{
		if(PAD_ButtonsDown(controller)&PAD_BUTTON_B)
		{
			if(wait.B==0)
			{
				wait.B = 1;
				return 1;
			}
			if(wait.B==1)
			{
				return 0;
			}
		}
		else if(PAD_ButtonsUp(controller)&PAD_BUTTON_B)
		{
			wait.B = 0;
			return 0;
		}
		else return 0;
	}
	else if(button == Button.X)
	{
		if(PAD_ButtonsDown(controller)&PAD_BUTTON_X)
		{
			if(wait.X==0)
			{
				wait.X = 1;
				return 1;
			}
			if(wait.X==1)
			{
				return 0;
			}
		}
		else if(PAD_ButtonsUp(controller)&PAD_BUTTON_X)
		{
			wait.X = 0;
			return 0;
		}
		else return 0;
	}
	else if(button == Button.Y)
	{
		if(PAD_ButtonsDown(controller)&PAD_BUTTON_Y)
		{
			if(wait.Y==0)
			{
				wait.Y = 1;
				return 1;
			}
			if(wait.Y==1)
			{
				return 0;
			}
		}
		else if(PAD_ButtonsUp(controller)&PAD_BUTTON_Y)
		{
			wait.Y = 0;
			return 0;
		}
		else return 0;
	}
	else if(button == Button.Z)
	{
		if(PAD_ButtonsDown(controller)&PAD_TRIGGER_Z)
		{
			if(wait.Z==0)
			{
				wait.Z = 1;
				return 1;
			}
			if(wait.Z==1)
			{
				return 0;
			}
		}
		else if(PAD_ButtonsUp(controller)&PAD_TRIGGER_Z)
		{
			wait.Z = 0;
			return 0;
		}
		else return 0;
	}
	else if(button == Button.L)
	{
		if(PAD_ButtonsDown(controller)&PAD_TRIGGER_L)
		{
			if(wait.L==0)
			{
				wait.L = 1;
				return 1;
			}
			if(wait.L==1)
			{
				return 0;
			}
		}
		else if(PAD_ButtonsUp(controller)&PAD_TRIGGER_L)
		{
			wait.L = 0;
			return 0;
		}
		else return 0;
	}
	else if(button == Button.R)
	{
		if(PAD_ButtonsDown(controller)&PAD_TRIGGER_R)
		{
			if(wait.R==0)
			{
				wait.R = 1;
				return 1;
			}
			if(wait.R==1)
			{
				return 0;
			}
		}
		else if(PAD_ButtonsUp(controller)&PAD_TRIGGER_R)
		{
			wait.R = 0;
			return 0;
		}
		else return 0;
	}
	else if(button == Button.UP)
	{
		if(PAD_ButtonsDown(controller)&PAD_BUTTON_UP)
		{
			if(wait.UP==0)
			{
				wait.UP = 1;
				return 1;
			}
			if(wait.UP==1)
			{
				return 0;
			}
		}
		else if(PAD_ButtonsUp(controller)&PAD_BUTTON_UP)
		{
			wait.UP = 0;
			return 0;
		}
		else return 0;
	}
	else if(button == Button.DOWN)
	{
		if(PAD_ButtonsDown(controller)&PAD_BUTTON_DOWN)
		{
			if(wait.DOWN==0)
			{
				wait.DOWN = 1;
				return 1;
			}
			if(wait.DOWN==1)
			{
				return 0;
			}
		}
		else if(PAD_ButtonsUp(controller)&PAD_BUTTON_DOWN)
		{
			wait.DOWN = 0;
			return 0;
		}
		else return 0;
	}
	else if(button == Button.LEFT)
	{
		if(PAD_ButtonsDown(controller)&PAD_BUTTON_LEFT)
		{
			if(wait.LEFT==0)
			{
				wait.LEFT = 1;
				return 1;
			}
			if(wait.LEFT==1)
			{
				return 0;
			}
		}
		else if(PAD_ButtonsUp(controller)&PAD_BUTTON_LEFT)
		{
			wait.LEFT = 0;
			return 0;
		}
		else return 0;
	}
	else if(button == Button.RIGHT)
	{
		if(PAD_ButtonsDown(controller)&PAD_BUTTON_RIGHT)
		{
			if(wait.RIGHT==0)
			{
				wait.RIGHT = 1;
				return 1;
			}
			if(wait.RIGHT==1)
			{
				return 0;
			}
		}
		else if(PAD_ButtonsUp(controller)&PAD_BUTTON_RIGHT)
		{
			wait.RIGHT = 0;
			return 0;
		}
		else return 0;
	}
	else if(button == Button.START)
	{
		if(PAD_ButtonsDown(controller)&PAD_BUTTON_START)
		{
			if(wait.START==0)
			{
				wait.START = 1;
				return 1;
			}
			if(wait.START==1)
			{
				return 0;
			}
		}
		else if(PAD_ButtonsUp(controller)&PAD_BUTTON_START)
		{
			wait.START = 0;
			return 0;
		}
		else return 0;
	}
	else if(button == Button.AUP)
	{
		if(PAD_StickY(controller)>36)
		{
			if(wait.AUP==0)
			{
				wait.AUP = 1;
				return 1;
			}
			if(wait.AUP==1)
			{
				return 0;
			}
		}
		else if(PAD_StickY(controller)<36)
		{
			wait.AUP = 0;
			return 0;
		}
		else return 0;
	}
	else if(button == Button.ADOWN)
	{
		if(PAD_StickY(controller)<-36)
		{
			if(wait.ADOWN==0)
			{
				wait.ADOWN = 1;
				return 1;
			}
			if(wait.ADOWN==1)
			{
				return 0;
			}
		}
		else if(PAD_StickY(controller)>-36)
		{
			wait.ADOWN = 0;
			return 0;
		}
		else return 0;
	}
	else if(button == Button.ALEFT)
	{
		if(PAD_StickX(controller)>36)
		{
			if(wait.ALEFT==0)
			{
				wait.ALEFT = 1;
				return 1;
			}
			if(wait.ALEFT==1)
			{
				return 0;
			}
		}
		else if(PAD_StickX(controller)<36)
		{
			wait.ALEFT = 0;
			return 0;
		}
		else return 0;
	}
	else if(button == Button.ARIGHT)
	{
		if(PAD_StickX(controller)<-36)
		{
			if(wait.ARIGHT==0)
			{
				wait.ARIGHT = 1;
				return 1;
			}
			if(wait.ARIGHT==1)
			{
				return 0;
			}
		}
		else if(PAD_StickX(controller)>-36)
		{
			wait.ARIGHT = 0;
			return 0;
		}
		else return 0;
	}
	else if(button == Button.CUP)
	{
		if(PAD_StickY(controller)>15)
		{
			if(wait.CUP==0)
			{
				wait.CUP = 1;
				return 1;
			}
			if(wait.CUP==1)
			{
				return 0;
			}
		}
		else if(PAD_StickY(controller)<15)
		{
			wait.CUP = 0;
			return 0;
		}
		else return 0;
	}
	else if(button == Button.CDOWN)
	{
		if(PAD_StickY(controller)<-15)
		{
			if(wait.CDOWN==0)
			{
				wait.CDOWN = 1;
				return 1;
			}
			if(wait.CDOWN==1)
			{
				return 0;
			}
		}
		else if(PAD_StickY(controller)>-15)
		{
			wait.CDOWN = 0;
			return 0;
		}
		else return 0;
	}
	else if(button == Button.CLEFT)
	{
		if(PAD_StickX(controller)>15)
		{
			if(wait.CLEFT==0)
			{
				wait.CLEFT = 1;
				return 1;
			}
			if(wait.CLEFT==1)
			{
				return 0;
			}
		}
		else if(PAD_StickX(controller)<15)
		{
			wait.CLEFT = 0;
			return 0;
		}
		else return 0;
	}
	else if(button == Button.CRIGHT)
	{
		if(PAD_StickX(controller)<-15)
		{
			if(wait.CRIGHT==0)
			{
				wait.CRIGHT = 1;
				return 1;
			}
			if(wait.CRIGHT==1)
			{
				return 0;
			}
		}
		else if(PAD_StickX(controller)>-15)
		{
			wait.CRIGHT = 0;
			return 0;
		}
		else return 0;
	}
	return 0;
}

bool button_held(u8 controller, u8 button)
{
	if(button == Button.A)
	{
		if(PAD_ButtonsHeld(controller)&PAD_BUTTON_A) return 1;
		else return 0;
	}
	else if(button == Button.B)
	{
		if(PAD_ButtonsHeld(controller)&PAD_BUTTON_B) return 1;
		else return 0;
	}
	else if(button == Button.X)
	{
		if(PAD_ButtonsHeld(controller)&PAD_BUTTON_X) return 1;
		else return 0;
	}
	else if(button == Button.Y)
	{
		if(PAD_ButtonsHeld(controller)&PAD_BUTTON_Y) return 1;
		else return 0;
	}
	else if(button == Button.Z)
	{
		if(PAD_ButtonsHeld(controller)&PAD_TRIGGER_Z) return 1;
		else return 0;
	}
	else if(button == Button.L)
	{
		if(PAD_ButtonsHeld(controller)&PAD_TRIGGER_L) return 1;
		else return 0;
	}
	else if(button == Button.R)
	{
		if(PAD_ButtonsHeld(controller)&PAD_TRIGGER_R) return 1;
		else return 0;
	}
	else if(button == Button.START)
	{
		if(PAD_ButtonsHeld(controller)&PAD_BUTTON_START) return 1;
		else return 0;
	}
	else if(button == Button.UP)
	{
		if(PAD_ButtonsHeld(controller)&PAD_BUTTON_UP) return 1;
		else return 0;
	}
	else if(button == Button.DOWN)
	{
		if(PAD_ButtonsHeld(controller)&PAD_BUTTON_DOWN) return 1;
		else return 0;
	}
	else if(button == Button.LEFT)
	{
		if(PAD_ButtonsHeld(controller)&PAD_BUTTON_LEFT) return 1;
		else return 0;
	}
	else if(button == Button.RIGHT)
	{
		if(PAD_ButtonsHeld(controller)&PAD_BUTTON_RIGHT) return 1;
		else return 0;
	}
	else return 0;
}

static inline bool button_wait(u8 controller, u8 button)
{
	while(1)
	{
		PAD_ScanPads();
		if(button_newpress(controller,button))
			return 1;
	}
}

void MAIN_Init()
{
	VIDEO_Init();
	PAD_Init();
	
	switch(VIDEO_GetCurrentTvMode())
	{
		case VI_NTSC:
			rmode = &TVNtsc480IntDf;
			break;
		case VI_PAL:
			rmode = &TVPal528IntDf;
			break;
		case VI_MPAL:
			rmode = &TVMpal480IntDf;
			break;
		default:
			rmode = &TVNtsc480IntDf;
			break;
	}

	xfb = MEM_K0_TO_K1(SYS_AllocateFramebuffer(rmode));
	console_init(xfb,20,20,rmode->fbWidth,rmode->xfbHeight,rmode->fbWidth*VI_DISPLAY_PIX_SZ);
	
	VIDEO_Configure(rmode);
	VIDEO_SetNextFramebuffer(xfb);
	VIDEO_SetBlack(FALSE);
	VIDEO_Flush();
	VIDEO_WaitVSync();
	if(rmode->viTVMode&VI_NON_INTERLACE) VIDEO_WaitVSync();
	VIDEO_ClearFrameBuffer (rmode,xfb,COLOR_BLACK);
	Button.A = 0;
	Button.B = 1;
	Button.X = 2;
	Button.Y = 3;
	Button.Z = 4;
	Button.L = 5;
	Button.R = 6;
	Button.UP = 7;
	Button.DOWN = 8;
	Button.LEFT = 9;
	Button.RIGHT = 10;
	Button.START = 11;
	Button.AUP = 12;
	Button.ADOWN = 13;
	Button.ALEFT = 14;
	Button.ARIGHT = 15;
	Button.CUP = 16;
	Button.CDOWN = 17;
	Button.CLEFT = 18;
	Button.CRIGHT = 19;
}

int main(int argc, char **argv)
{
	MAIN_Init();

	error:
	printf("   Starting Net_Init()...\n");

	int Connect = net_init();
	if(Connect != 0)
	{
		printf("   Net_Init() failed.\n");
		printf("   Press A to retry.\n");
		button_wait(0,Button.A);
		goto error;
	}

	printf("   Net_Init() successful.\n\n");

	printf("   Net_Socket Initializing.\n");
	s32 netSocket = net_socket(AF_INET, SOCK_STREAM, 0);

	if(netSocket == INVALID_SOCKET)
	{
		printf("   Net_Socket Initialization failed.\n");
		printf("   Press A to retry.\n");
		button_wait(0,Button.A);
		goto error;
	}

	printf("   Net_Socket Initialized.\n\n");

	printf("   Establishing server on port %d.\n",port);
	sockaddr_in sin;
	sin.sin_port=htons(port);
	sin.sin_addr.s_addr=INADDR_ANY;
	sin.sin_family=AF_INET;

	if(net_bind(netSocket,(sockaddr*)&sin, sizeof(sin)) == SOCKET_ERROR)
	{
		printf("   Failed to bind.\n");
		printf("   Press A to retry.\n");
		button_wait(0,Button.A);
		goto error;
	}

	printf("   Server established!\n");

	ip = net_gethostip();
	printf("   You Wii's ip address is %d.%d.%d.%d\n", splitip[0], splitip[1], splitip[2], splitip[3]);
	printf("   Waiting for client to connect...\n");

	while (net_listen(netSocket, 1) == SOCKET_ERROR);

	int client;
	u32 len = sizeof(sin);
	client=net_accept(netSocket, (sockaddr*)&sin, &len);
	printf("   Connection established from  %d.%d.%d.%d\n\n",
	(sin.sin_addr.s_addr >> 24) & 0xFF,
	(sin.sin_addr.s_addr >> 16) & 0xFF,
	(sin.sin_addr.s_addr >> 8) & 0xFF,
	(sin.sin_addr.s_addr) & 0xFF);
	
	while(1)
	{
		net_recv(client, message, sizeof(message), 0);
		printf("   PC: %s \n",message);
		if(message[0] == 'e' && message[1] == 'x' && message[2] == 'i' && message[3] == 't' && message[4] == NULL)
		{
			net_close(netSocket);
			goto end;
		}
	}

	end:
	VIDEO_ClearFrameBuffer (rmode,xfb,COLOR_BLACK);
	printf("   I couldn't figure out how to go back to the loader.\n   So you can reset your Wii now...\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n");
	return 0;
}
